<!DOCTYPE html>
<html lang="en">

<head>

    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>task 26.10 Load all orders - Danh sách đơn hàng</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
    <div class="container-fluid">
        <div class="row">
            <div class="col-12">
                <h2 class="text-center">Danh sách đơn hàng</h2>
                <table class="table text-center table-striped" id="table-order">
                    <thead>
                        <tr>
                            <th scope="col">Order Code</th>
                            <th scope="col">Kích cỡ combo</th>
                            <th scope="col">Loại pizza</th>
                            <th scope="col">Nước uống</th>
                            <th scope="col">Thành tiền</th>
                            <th scope="col">Họ và tên</th>
                            <th scope="col">Số điện thoại</th>
                            <th scope="col">Trạng thái</th>
                            <th scope="col">Chi tiết</th>
                        </tr>
                    </thead>
                    <tbody>

                    </tbody>
                </table>
            </div>
        </div>
    </div>

    <script>
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        const gREQUEST_CREATE_SUCCESS = 201; // status 201 - tạo thành công
        const gREQUEST_DELETE_SUCCESS = 204; // status 204 - Xóa thành công
        const vBASE_DELETE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
        

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        // Hàm thực hiện khi load trang
        function onPageLoading() {
            getAllOrders();
        }

        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        // Hàm thực hiện việc load all orders từ server và load vào table
        function getAllOrders() {
             /**
            * Chia để trị - 04 bước cố gắng thành 04 functions riêng biệt
            */
            // B1: Thu thập dữ liệu (trong bài này bước này ko cần)
            // B2: Validate dữ liệu (trong bài này bước này ko cần)
            // B3: Thực hiện việc gọi API từ server Server
            var vXmlHttpGetAllOrders = new XMLHttpRequest();
            callApiToGetAllOrders(vXmlHttpGetAllOrders);

            // B4: Xử lý trên front-end khi request xử lý xong và trả về response thành công
            vXmlHttpGetAllOrders.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    loadOrderToTable(vXmlHttpGetAllOrders);
                }
            }
        }

        // hàm gọi api để lấy all orders
        function callApiToGetAllOrders(paramXMLHttpGetAllOrders) {
            const vBaseUrl = "http://203.171.20.210:8080/devcamp-pizza365/orders";
            paramXMLHttpGetAllOrders.open("GET", vBaseUrl, true);
            paramXMLHttpGetAllOrders.send();
        }
        //hàm gọi api xóa một order theo id
        function callApiDeleteOrderClick(paramId) {
            
            var vXmlHttpOrder = new XMLHttpRequest();
            vXmlHttpOrder.open("DELETE", vBASE_DELETE_URL + "/" + paramId, true);
            vXmlHttpOrder.send();
            vXmlHttpOrder.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK) {
                    if(this.status == gREQUEST_DELETE_SUCCESS){
                        console.log("Delete order " + paramId + " thành công!");
                        alert("Xóa đơn hàng thành công");
                        location.reload();
                    }
                    else{
                        console.log("Delete order " + paramId + "Không thành công!");
                        alert("Xóa đơn hàng không thành công");
                    }
                }   
                }
        }

        // input: xml http request đã đươc trả lời
        // ouptut/end: dữ liệu hiên thi trên bảng
        function loadOrderToTable(paramXMLHttpAllOrder) {
            //CODE Ở ĐÂY ĐỂ LOAD DATA VÀO TABLE
            //chuyển JSON về obj
            var vOrderObj = JSON.parse(paramXMLHttpAllOrder.responseText);
            //truy xuất tabel
            var vTalbel = document.getElementById("table-order");
            //duyệt qua mảng và tạo tạo dòng mới
            for(var bI = 0; bI < vOrderObj.length; bI++){
                var bRow = vTalbel.insertRow(-1);
                var bCellOrderCode = bRow.insertCell(0);
                bCellOrderCode.innerHTML = vOrderObj[bI].orderCode;

                var bCellKichCoCombo = bRow.insertCell(1);
                bCellKichCoCombo.innerHTML = vOrderObj[bI].kichCo;

                var bCellLoaiPizza =  bRow.insertCell(2);
                bCellLoaiPizza.innerHTML = vOrderObj[bI].loaiPizza;

                var bCellNuocUong = bRow.insertCell(3);
                bCellNuocUong.innerHTML = vOrderObj[bI].soLuongNuoc;

                var bCellThanhTien = bRow.insertCell(4);
                bCellThanhTien.innerHTML = vOrderObj[bI].thanhTien;

                var bCellHoVaTen = bRow.insertCell(5);
                bCellHoVaTen.innerHTML = vOrderObj[bI].hoTen;

                var bCellSoDienThoai = bRow.insertCell(6);
                bCellSoDienThoai.innerHTML = vOrderObj[bI].soDienThoai;

                var bCellTrangThai = bRow.insertCell(7);
                bCellTrangThai.innerHTML = vOrderObj[bI].trangThai;
                
                var bCellChiTiet = bRow.insertCell(8);
                //tạo nút button
                var bButton = document.createElement("button");
                bButton.innerHTML = "Chi tiết";
                bButton.className = "btn btn-primary order-detail";
                bButton.setAttribute("data-order-id", vOrderObj[bI].id);
                bButton.setAttribute("data-order-code", vOrderObj[bI].orderCode);
                // Thêm sự kiện click cho nút button
                (function (index) {
                    bButton.addEventListener('click', function () {
                        console.log(vOrderObj[index].id);
                        console.log(vOrderObj[index].orderCode);
                        //gọi form OrderDetail hiển thị chi tiết order
                        const vDETAIL_URL = "http://127.0.0.1:5500/2023-04-08/Task%2026.20/Task%2026.20%20Orderdetail.html";
                        var vUrlOpen = vDETAIL_URL + "?" + "id=" + vOrderObj[index].id + "&" + "orderCode=" + vOrderObj[index].orderCode;
                        window.location.href = vUrlOpen;
                    });
                })(bI);
                bCellChiTiet.appendChild(bButton);

                //tạo nut btn red
                var bBtnRed = document.createElement('button');
                bBtnRed.innerHTML = "Delete";
                bBtnRed.className = "btn btn-danger delete-detail";
                bBtnRed.setAttribute("data-order-id",  vOrderObj[bI].id);
                bBtnRed.setAttribute("data-order-code",  vOrderObj[bI].orderCode);
                //thêm sự kiện click cho nút btn delete
                (function (index) {
                    bBtnRed.addEventListener('click', function (){
                        if(confirm("Bạn có chắc chắn muốn xóa đơn hàng này hay không ?")){
                            var vOrderId = vOrderObj[index].id;
                            callApiDeleteOrderClick(vOrderId);
                        }
                    })
                })(bI);
                bCellChiTiet.appendChild(bBtnRed);
            }
        }


        
    </script>
</body>

</html>